<?php

/*________________________________________________________

  (C) 2003--2004 Maxim Proskurnya,     max@axofiber.org.ru
  All rights reserved.
  ________________________________________________________

  HTForT v0.6

  Translator of mathematic formula from SGML to HTML 
  with CSS 2.0

  This software is freeware and without any warranty and
  functionability. This software is not for commercial
  purpose or sale. You are free to modify or redistribute
  this script free  of charge under the following 
  conditions: redistributions of source code must retain
  the above copyright notice and the current disclaimer.
  ________________________________________________________
*/

require ( "xml.lib.inc" );

class Formula
{
  // HTFort revision to display while pops-up comment in the
  // generated HTML-code.

  var $HTForTVersion = '0.6';

  // Debug condition based interpretation
  //$Debug = true;
  var $Debug = False;

  // Path to htfort directory, relative to the http-server
  // document's root
  var $HTForTPath    = '/utils/';

  // 
  var $StartSize     = 18;

  // Default font size.
  var $DefaultSymbolSize = 18;

  // Default font-size decrement for sublevels in formula.
  var $FontSizeDownStep = 4;

  // Positive compensation for "Sigma" simbol in "sum" formula
  var $SigmaCapSizeCompensation = 4;

  // Default baseline pitch offset, i.e. number of pixels
  // to shift vertical up/down while processing super- and
  // subscript.
  var $SuperScriptPitch = 4;
  var $SubScriptPitch   = 8;

  var $BaseLine;
  var $BlockSize;

  function PrintFormula ( $Formula )
  {
    $BaseLine  = 19;
    $BlockSize = 19;
    $Level     = 0;

  $BaseLine = 0;
  return "\n\n<!-- HTML generated by HTFort v" . $this->HTForTVersion . "-->
<span title=\"&lt;-- Generated by HTForT v" . $this->HTForTVersion . 
" from XML--&gt;". HTMLSpecialChars ( $Formula ) ."\" onMouseOver=\"status='http://axofiber.no-ip.org/projects/htfort/'\"
onMouseOut=\"status=''\" onClick=\"document.location='http://axofiber.org.ru/htfort/'\" style=\"cursor:help;font-family:serif;vertical-align:top;display:block;\">\n" .
  $this->PrintFormulaEx ( ReadXML ( $Formula ), $Level, $BaseLine, $BlockSize ) .
  "</span>\n<!-- HTForT end formula -->\n\n";
  }

function PrintFormulaEX ( & $XML, $Level, & $BaseLine, & $BlockSize )
{
  $BaseLine  = 0;
  $BlockSize = 0;

  $i = 0;
  $Result = "";

  foreach ( $XML as $Element )
  {
    $_BlockSize = 0;
    if ( $Element["ELEM"] == "TEXT" )
    {
      // Body
      $Blocks[$i][0] = "<span class=f style=font-size:" . ( $this->StartSize - $Level ) . "px>" . 
                       TranslateText ( $Element["BODY"] ) . "</span>";
      $Blocks[$i][1] = $_BaseLine  = 0;
      $_BlockSize    = $this->StartSize - $Level;
    }
    else if ( $Element["ELEM"] == "TAG" )
    {
      $Name = $Element["NAME"];
      if ( empty ($Element["BODY"]) )
      {
        if ( $Name == "cos" || $Name == "sin" || $Name == "tg" || $Name == "ctg" || 
             $Name == "exp" || $Name == "log" || $Name == "ln" || $Name == "lg"  || 
             $Name == "sh"  || $Name == "ch"  || 
             $Name == "arccos" || $Name == "arcsin" || $Name == "arctg" || $Name == "arcctg" || 
             $Name == "arcsh" || $Name == "arcch"   )
        {
          $Blocks[$i][0] = "<span class=f style=\"font-size:" . ( $this->StartSize - $Level ) . "px\">" . $Element["NAME"] . "</span>";
          $Blocks[$i][1] = $_BaseLine  = 0;
          $_BlockSize = $this->StartSize - $Level;
        }
      }
      else
      {
        if ( $Name == "b" )
        {
          $Blocks[$i][0] = "<b>" . $this->PrintFormulaEx ( $Element["BODY"], $Level, $_BaseLine, $_BlockSize ) . "</b>";
          $Blocks[$i][1] = $_BaseLine;
        }
        else
        if ( $Name == "i" )
        {
          $Blocks[$i][0] = "<i>" . $this->PrintFormulaEx ( $Element["BODY"], $Level, $_BaseLine, $_BlockSize ) . "</i>";
          $Blocks[$i][1] = $_BaseLine;
        }
        else      
        if ( $Name == "sup" )
        {
          $Blocks[$i][0] = $this->PrintFormulaEx ( $Element["BODY"], $Level + $this->FontSizeDownStep, $_BaseLine, $_BlockSize );
          $Blocks[$i][1] = $_BaseLine -= $this->SuperScriptPitch;
          $_BlockSize  = ( $this->StartSize - $Level ) + $this->SuperScriptPitch;
        }
        else
        if ( $Name == "sub" )
        {
          $Blocks[$i][0] = $this->PrintFormulaEx ( $Element["BODY"], $Level + $this->FontSizeDownStep, $_BaseLine, $_BlockSize );
          $Blocks[$i][1] = $_BaseLine += $this->SubScriptPitch;
          $_BlockSize  = ( $this->StartSize - $Level ) + $this->SubScriptPitch;
        }
        else
        if ( $Name == "pow" )
        {
          unset ( $Index );
          unset ( $Body );
          
          foreach ( $Element["BODY"] as $SubElement )
          {
            if ( $SubElement["ELEM"] == "TAG" )
              if ( $SubElement["NAME"] == "f" )
                $Body = $SubElement["BODY"];
              else if ( $SubElement["NAME"] == "index" )
                $Index = $SubElement["BODY"];
          }
          if ( isset ( $Body ) )
          {
            $Blocks[$i][0] = $this->PrintFormulaEx ( $Body, $Level, $_BaseLine, $_BlockSize );
            $Blocks[$i][1] = $_BaseLine;
            UpdateOffsets ( $BaseLine, $BlockSize, $_BaseLine, $_BlockSize, $i );
          }
          else
            if ( $this->Debug ) print ( "HTFort parsing error: the body of &lt;pow&gt; element is absent.<br>" );
          
          if ( isset ( $Index ) )
          {
            $Blocks[$i][0] = $this->PrintFormulaEx ( $Index, $Level + $this->FontSizeDownStep, $_BaseLine, $_BlockSize );
            $_BlockSize += $this->SuperScriptPitch;
            $Blocks[$i][1] = $_BaseLine -= $this->SuperScriptPitch;
          }
          else
            if ( $this->Debug ) print ( "HTFort parsing error: the index of &lt;pow&gt; element is absent.<br>" );
        }
        else
        if ( $Name == "fraq" )
        {
          unset ( $Num );
          unset ( $Den );
          $_temp = 0;
          
          foreach ( $Element["BODY"] as $Subelement )
          {
            if ( $Subelement["ELEM"] == "TAG" )
              if ( $Subelement["NAME"] == "num" )
                $Num = $Subelement["BODY"];
              else if ( $Subelement["NAME"] == "den" )
                $Den = $Subelement["BODY"];
          }
          $Blocks[$i][0] = "
<table cellspacing=0 cellpadding=0 class=HTFence>
<tr><td align=center class=HTFraq>";
          if ( isset ( $Num ) ) 
          {
            $Blocks[$i][0] .= $this->PrintFormulaEx ( $Num, $Level, $_BaseLine, $_BlockSize );
            $Blocks[$i][1] = $_BaseLine - ( $this->StartSize - $Level + $this->FontSizeDownStep ) / 2;
            $_temp = $_BlockSize;
          }
          else
            if ( $this->Debug ) print ( "HTFort parsing error: the numerator of &lt;fraq&gt; element is absent.<br>" );
          
          $Blocks[$i][0] .=  "
</td></tr>
<tr><td align=center style=\"padding-top:2px\">";
          if ( isset ( $Den ) ) 
            $Blocks[$i][0] .= $this->PrintFormulaEx ( $Den, $Level, $_BaseLine, $_BlockSize );
          else
            if ( $this->Debug ) print ( "HTFort parsing error: the denominator of &lt;fraq&gt; element is absent.<br>" );
          
          $Blocks[$i][0] .= "
</td></tr>
</table>";
          $_BlockSize += $_temp + 4;
          $_BaseLine = $Blocks[$i][1];
        }
        else
        if ( $Name == "fence" )
        {
          // Fence
          if ( empty ($Element["ATTRS"]["type"]) )
            $Type = "circle";
          else
            $Type = $Element["ATTRS"]["type"];        
          if ( 5 < $Level )
            $Thickness = 1;
          else
            $Thickness = 2;
  
          $Res  = $this->PrintFormulaEx ( $Element["BODY"], $Level, $_BaseLine, $_BlockSize );
          if ( $Type == "flat" )
          {
            $Blocks[$i][0] = "
<table cellspacing=0 cellpadding=0 class=HTFence style=\"border:1px solid black;border-top-width:0px;border-bottom-width:0px;\">
<tr><td class=HTFenceBody>
" . $Res . "
</td></tr>
</table>";
            $Blocks[$i][1] = $_BaseLine;
          }
          else if ( $Type == "square" )
          {
            if ( 0 < $this->StartSize - $Level )
              $FenceWidth = ( $this->StartSize - $Level ) / 4;
            else
              $FenceWidth = 1;
            $Blocks[$i][0] = "
<table cellspacing=0 cellpadding=0 class=HTFence>
<tr>
<td style=\"border: 1px solid black;border-left-width:". $Thickness ."px;border-right-width:0px;width:". $FenceWidth . "px\">
<img src=\"". $this->HTForTPath. "symbols/trans.gif\" width=1 height=1 border=0>
</td>
<td style=\"border:none;\"><td class=HTFenceBody>
" . $Res . "
</td>
<td style=\"border: 1px solid black;border-left-width:0px;border-right-width:". $Thickness ."px;width:". $FenceWidth . "px\">
<img src=\"". $this->HTForTPath . "symbols/trans.gif\" width=1 height=1 border=0></td>
</tr>
</table>";
            $Blocks[$i][1] = $_BaseLine;
            $_BlockSize += 4;
          }
          else
          {
            if ( $_BlockSize < 30 )
            {
              $FenceSize = $this->StartSize;
              if ( $_BaseLine < 0 ) 
                $FenceSize -= $_BaseLine;
              $Blocks[$i][0] = "
<table cellspacing=0 cellpadding=0 class=HTFence>
<tr valign=top>
<td>
<span class=f style=\"font-size:" . $FenceSize . "px\">(</span></td>
<td>
" . $Res . "
</td>
<td>
<span class=f style=\"font-size:" . $FenceSize . "px\">)</span></td>
</tr>
</table>";
              $Blocks[$i][1] = $_BaseLine;
            }
            else
            {
              $Blocks[$i][0] = "
<table cellspacing=0 cellpadding=0 class=HTFence >
<tr>
<td>

<table cellpadding=0 cellspacing=0 class=HTFence>
<tr><td><img src=\"" . $this->HTForTPath . "symbols/topleftark.gif\" width=7 height=8 border=0></td>
<tr><td><img src=\"" . $this->HTForTPath . "symbols/linevertical.gif\" width=7 height=" . ( $_BlockSize -  18 ) . " border=0></td>
<tr><td><img src=\"" . $this->HTForTPath . "symbols/bottomleftark.gif\" width=7 height=8 border=0></td>
</table>

</td>
<td>
" . $Res . "
</td>
<td>

<table cellpadding=0 cellspacing=0 class=HTFence>
<tr><td><img src=\"" . $this->HTForTPath . "symbols/toprightark.gif\" width=7 height=8 border=0></td>
<tr><td><img src=\"" . $this->HTForTPath . "symbols/linevertical.gif\" width=7 height=" . ( $_BlockSize -  18 ) . " border=0></td>
<tr><td><img src=\"" . $this->HTForTPath . "symbols/bottomrightark.gif\" width=7 height=8 border=0></td>
</table>

</td>
</tr>
</table>";
              $Blocks[$i][1] = $_BaseLine;
            }
          }
        }
        else
        if ( $Name == "sqrt" )
        {
          unset ( $Index );
          unset ( $Body );
          $Thickness = 1;
          $SqrtSizePitch = 1;
          $Blocks[$i][0] = "";
  
          foreach ( $Element["BODY"] as $Subelement )
          {
            if ( $Subelement["ELEM"] == "TAG" )
              if ( $Subelement["NAME"] == "index" )
              {
                $Index = $this->PrintFormulaEx ( $Subelement["BODY"], $Level + $this->FontSizeDownStep, $_BaseLine, $_BlockSize );
                $SqrtSizePitch += $_BlockSize - $this->FontSizeDownStep;
              }
              else if ( $Subelement["NAME"] == "f" )
              {
                $Body = $this->PrintFormulaEx ( $Subelement["BODY"], $Level, $_BaseLine, $_BlockSize );
                $Blocks[$i][1] = $_BaseLine;
                $temp2 = $_BlockSize;
              }
          }
          if ( 0 <= $SqrtSizePitch + $_BaseLine )
            $SqrtSizePitch += $_BaseLine;
          if ( 40 <= $_BlockSize )
            $Thickness = 2;
          $_BaseLine    -= $SqrtSizePitch + $Thickness;
          $_BlockSize   += $SqrtSizePitch + $Thickness + 4;
          $Blocks[$i][1] = $_BaseLine;
          $Blocks[$i][0] .= "
<table cellspacing=0 cellpadding=0 class=HTFence>
<tr style=\"vertical-align:top;\">
<td>";
          if ( isset ( $Index ) ) 
            $Blocks[$i][0] .= $Index;
          else
            if ( $this->Debug ) print ( "HTFort parsing error: the index of &lt;sqrt&gt; element is absent.<br>" );
          $Blocks[$i][0] .= "
</td>
<td><img src=\"". $this->HTForTPath ."symbols/root.gif\" height=". $_BlockSize ."></td>
<td style=\"border: 0px solid black;border-top-width:" . $Thickness . "px;";
          if ( 0 < $SqrtSizePitch  ) 
            $Blocks[$i][0] .= "padding-top:". $SqrtSizePitch ."px";
          $Blocks[$i][0] .= "\">";
          if ( isset ( $Body ) ) 
            $Blocks[$i][0] .= $Body;
          else
            if ( $this->Debug ) print ( "HTFort parsing error: the body of &lt;sqrt&gt; element is absent.<br>" );
            
          $Blocks[$i][0] .= "
</td></tr></table>";
        }
        else
        if ( $Name == "sum" )
        {
          $From = "";
          $To   = "";
          $Body = "";
          $_temp = 0;
          $FromBlockSize = 0;
          $ToBlockSize   = 0;
          $BodyBlockSize = 0;

          foreach ( $Element["BODY"] as $SubElement )
          {
            if ( $SubElement["NAME"] == "to" )
              $To   = $this->PrintFormulaEx ( $SubElement["BODY"], $Level + $this->FontSizeDownStep, $_temp, $ToBlockSize );
            else
            if ( $SubElement["NAME"] == "from" )
              $From = $this->PrintFormulaEx ( $SubElement["BODY"], $Level + $this->FontSizeDownStep, $_temp, $FromBlockSize );
            else
            if ( $SubElement["NAME"] == "f" )
              $Body = $this->PrintFormulaEx ( $SubElement["BODY"], $Level, $_BaseLine, $BodyBlockSize );
          }
          $_BlockSize = $ToBlockSize + $FromBlockSize + $BodyBlockSize;
          $_BaseLine -= $ToBlockSize;
          $Blocks[$i][0] = "<table cellspacing=0 cellpadding=0 class=HTFence";
if ( $this->Debug ) $Blocks[$i][0] .= " border=1";
          $Blocks[$i][0] .= ">
<tr valign=top><td><table cellspacing=0 cellpadding=0>
<tr><td align=center>
" . $To . "
</td></tr>
<tr style=\"line-height:" . $BodyBlockSize. "px\"><td align=center><span class=f style=font-size:" . ( $BodyBlockSize + $this->SigmaCapSizeCompensation ). "px>&#8721</span></td></tr>
<tr><td align=center>
" . $From . "
</td></tr>
</table>
</td>";
          if ( 0 < $ToBlockSize )
            $Blocks[$i][0] .= "<td style=\"padding-top:" . $ToBlockSize . "px;\">";
          else
            $Blocks[$i][0] .= "<td>";
          $Blocks[$i][0] .= $Body . "
</td></tr>
</table>";
          $Blocks[$i][1] = $_BaseLine;
        }
/*
        else
        if
        {
integral - &#8747        
        }

*/
        else
        if ( $Element["NAME"] == "sym" )
        {
          if ( $Element["BODY"]["0"]["ELEM"] == "TEXT" )
          {
            $Symbol     = $Element["BODY"]["0"]["BODY"];
            $tempRes    = "";
            $tempImgRes = "";            

            include ( 'signs.table.inc' );

            if ( !empty ( $tempRes ) ) 
            {
              $Blocks[$i][0] = "<span class=f style=font-size:" . ( $this->StartSize - $Level )  . "px>" . $tempRes . "</span>";
              $Blocks[$i][1] = 0;
              $_BaseLine = 0;
              $_BlockSize = $this->StartSize - $Level;
            }
            if ( !empty ( $tempImgRes ) ) 
            {
              $Blocks[$i][0] = "<img src=\"". $this->HTForTPath ."symbols/" . $tempRes . "\" class=HTSymbol width=". ( $this->StartSize - $Level - 8 )  .">";
              $Blocks[$i][1] = 0;
              $_BaseLine = 0;
              $_BlockSize = $this->StartSize - $Level;
            }
          }
        }
        else
        {
          $Blocks[$i][0] = $this->PrintFormulaEx ( $Element["BODY"], $Level, $_BaseLine, $_BlockSize );
          $Blocks[$i][1] = $_BaseLine;
        }
      }
    }
    UpdateOffsets ( $BaseLine, $BlockSize, $_BaseLine, $_BlockSize, $i );
  }

  if ( $this->Debug )
    $Result = "<table class=f cellspacing=0 cellpadding=0 border=1><tr valign=top>";  
  else
    $Result = "<table class=f cellspacing=0 cellpadding=0><tr valign=top>";

  foreach ( $Blocks as $Block )
  {
    $MarginTop = abs ( $Block[1] - $BaseLine );
    if ( 0 < $MarginTop )
      $Result .= "<td style=\"padding-top:" . $MarginTop ."px\">";
    else
      $Result .= "<td>";
    $Result .= $Block[0] . "</td>";
//    $Result .= $Block[0] . "<small>(".$MarginTop . ")</small></td>";    
  }    
  $Result .= "</tr></table>";
  
  return $Result;
}

};


function UpdateOffsets ( & $BaseLine, & $BlockSize, $newBaseLine, $newBlockSize, & $i )
{
//  $newBlockSize += abs ( $newBaseLine );
  if ( $newBaseLine < $BaseLine )
    $BaseLine = $newBaseLine;
  if ( $BlockSize < $newBlockSize )
    $BlockSize  = $newBlockSize;
  ++$i;
}

function TranslateText ( $Text )
{
  $Result = "";
  $Italic = false;

  for ( $i = 0; $i < strlen ( $Text ); ++$i )
  {
    $c = $Text[$i];
    if ( "0" <= $c && $c <= "9" && $Italic )
    {
      $Italic = false;
      $Result .= "</i>";
    }
    else
    if ( ( "A" <= $c && $c <= "z" || "A" <= $c && $c <= "" ) && !$Italic )
    {
      $Italic = true;
      $Result .= "<i>";
    }
    else
    if ( $c == "-" ) $c = "&#150;";
    $Result .= $c;
  }
  if ( $Italic ) $Result .= "</i>";
  return $Result;
}



function HTForTStyle ()
{
  return "<style>
.f { 
 display:inline;
 font-family: times;
}
.HTSymbol {
 vertical-align:text-bottom
}
.HTFraq {
 border-width: 0px;
 border-style: solid;
 border-color: black;
 border-top-width: 0px;
 border-right-width: 0px;
 border-bottom-width: 1px;
 border-left-width: 0px;
 padding-bottom: 2px}
.HTFence { 
 display: inline;
 margin-top: 0px;
 margin-right: 2px;
 margin-bottom: 0px;
 margin-left: 2px;}
</style>
";
}

function HTForTPrint ( $XML )
{
  global $HTForTVersion;
} 
?>
